import { ModuleDescription, ModuleData, AdventureImage, CaptionImage } from "./IAdventure";
import { ModuleScene } from "./ModuleScene";
import { PdfData } from "../parse";
import { PageLayoutEmitFunction, PageLayout } from "./PageLayouts";
import * as EC from './extinctioncurse';
import { sentenceCase } from "./core";

const adventureModule : ModuleDescription = {
    prefix: "extinction-curse2",
    fullName: "Extinction Curse - Legacy of the Lost God",
    detect: (pdf: PdfData) => {
        return pdf.textDetails.some(t => t.text.trim() == 'EXTINCTION CURSE: LEGACY OF THE LOST GOD' && t.fontId == 'Gin-Regular:12');
    },
    extractDetails: EC.extractDetails,
    detectPageLayout: EC.detectPageLayout,
    pages: [
        // chapter 1
        new EC.ChapterHeadingPageLayout(6),
        new EC.RightSingleColumnWithSidebar(7),
        new EC.LeftTwoColumn(8),
        new EC.RightTwoColumn(9),
        new EC.LeftTwoColumn(10),
        new EC.RightTwoColumnWithRightCutout(11, 210),
        new EC.LeftTwoColumnWithMap(12, 340),
        new EC.RightTwoColumn(13),
        new EC.LeftTwoColumn(14),
        new EC.RightTwoColumn(15),
        new EC.LeftTwoColumn(16),
        new EC.RightTwoColumn(17),
        new EC.LeftTwoColumn(18),
        new EC.RightTwoColumn(19),

        // chapter 2
        new EC.ChapterHeadingPageLayout(20),
        new EC.RightSingleColumnWithSidebar(21),
        new EC.LeftTwoColumnWithMap(22, 340),
        new EC.RightTwoColumn(23),
        new EC.LeftTwoColumn(24),
        new EC.RightTwoColumn(25),
        new EC.LeftTwoColumn(26),
        new EC.RightTwoColumn(27),
        new EC.LeftTwoColumn(28),
        new EC.RightTwoColumn(29),
        new EC.LeftTwoColumn(30),
        new EC.RightTwoColumn(31),
        new EC.LeftTwoColumn(32),
        new EC.RightTwoColumn(33),

        // chapter 3
        new EC.ChapterHeadingPageLayout(34),
        new EC.RightSingleColumnWithSidebar(35),
        new EC.LeftTwoColumnWithMap(36, 340),
        new EC.RightTwoColumn(37),
        new EC.LeftTwoColumnWithMap(38, 472),
        new EC.RightTwoColumn(39),
        new EC.LeftTwoColumn(40),
        new EC.RightTwoColumn(41),
        new EC.LeftTwoColumn(42),
        new EC.RightTwoColumn(43),
        new EC.LeftTwoColumnWithLeftCutout(44, 365),
        new EC.RightTwoColumn(45),

        // chapter 4
        new EC.ChapterHeadingPageLayout(46),
        new EC.RightSingleColumnWithSidebar(47),
        // map on 48
        new EC.RightTwoColumn(49),
        new EC.LeftTwoColumn(50),
        new EC.RightTwoColumn(51),
        new EC.LeftTwoColumn(52),
        new EC.RightTwoColumn(53),
        new EC.LeftTwoColumn(54),
        new EC.RightTwoColumn(55),
        new EC.LeftTwoColumn(56),
        new EC.RightTwoColumn(57),
        new EC.LeftTwoColumn(58),
        new EC.RightTwoColumn(59),
        new EC.LeftTwoColumn(60),
        new EC.RightTwoColumn(61),

        // appendix 1
        new EC.RightChapterHeadingPageLayout(63),
        new EC.LeftTwoColumn(64),
        new EC.RightTwoColumnWithRightCutout(65, 160),
        new EC.LeftTwoColumn(66),
        new EC.RightTwoColumn(67),

        // appendix 2
        new EC.RightChapterHeadingPageLayout(69),
        new EC.LeftTwoColumn(70),
        new EC.RightTwoColumnWithRightCutout(71, 425),
        new EC.LeftTwoColumnWithLeftCutout(72, 245),
        new EC.RightTwoColumn(73),

        // adventure toolbox
        new EC.RightChapterHeadingPageLayout(75),
        new EC.LeftTwoColumn(76),
        new EC.RightTwoColumn(77),
        new EC.LeftTwoColumn(78),
        new EC.RightTwoColumn(79),
        new EC.LeftSingleColumnWithSidebar(80),
        new EC.RightSingleColumnWithSidebar(81),
        new EC.LeftSingleColumnWithSidebar(82),
        new EC.RightSingleColumnWithSidebar(83),
        new EC.LeftSingleColumnWithSidebar(84),
        new EC.RightSingleColumnWithSidebar(85),
        new EC.LeftSingleColumnWithSidebar(86),
        new EC.RightSingleColumnWithSidebar(87),
        new EC.ChapterHeadingPageLayout(88),
        new EC.RightTwoColumn(89),
        new EC.ChapterHeadingPageLayout(90),
        new EC.RightTwoColumn(91),
        new EC.ChapterHeadingPageLayout(92),
        new EC.RightTwoColumn(93),
    ],
    scenes: [
        new ModuleScene({
            name: 'map1',
            nameInfo: { x: 16, y: 758.8362 },
            nameFn: name => sentenceCase(name),
            page: 12, width: 1261, height: 880,
            imageLeft: 19, imageRight: 1253, imageCols: 55,
            imageTop: 3, imageBottom: 858, imageRows: 38,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map2',
            nameInfo: { x: 16, y: 758.8362 },
            nameFn: name => sentenceCase(name),
            page: 22, width: 1261, height: 880,
            imageLeft: 9, imageRight: 1147, imageCols: 40,
            imageTop: 40, imageBottom: 865, imageRows: 29,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map3',
            nameInfo: { x: 16, y: 394.6681 },
            nameFn: name => sentenceCase(name),
            page: 36, width: 1261, height: 880,
            imageLeft: 9, imageRight: 1147, imageCols: 40,
            imageTop: 52, imageBottom: 820, imageRows: 27,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map4',
            nameInfo: { x: 29, y: 747 },
            nameFn: name => sentenceCase(name),
            page: 48, width: 1261, height: 1637,
            imageLeft: 22, imageRight: 1255, imageCols: 41,
            imageTop: 19, imageBottom: 1612, imageRows: 53,
            globalLight: true,
        }),
    ],
    journals: [
        new AdventureImage({ name: 'journal1', page: 2, width: 589, height: 809, index: 0 }),
        new AdventureImage({ name: 'journal2', page: 2, width: 589, height: 809, index: 1 }),
        new AdventureImage({ name: 'journal3', page: 2, width: 589, height: 809, index: 2 }),
        new AdventureImage({ name: 'journal4', page: 2, width: 589, height: 809, index: 3 }),
        new AdventureImage({ name: 'journal5', page: 2, width: 589, height: 809, index: 4 }),
        new AdventureImage({ name: 'journal6', page: 2, width: 589, height: 809, index: 5 }),
        new AdventureImage({ name: 'journal7', page: 4, width: 1262, height: 1636 }),
        new AdventureImage({ name: 'journal8', page: 6, width: 1261, height: 805 }),
        new AdventureImage({ name: 'journal9', page: 20, width: 1259, height: 805 }),
        new AdventureImage({ name: 'journal10', page: 34, width: 1259, height: 805 }),
        new AdventureImage({ name: 'journal11', page: 46, width: 1259, height: 805 }),
        new AdventureImage({ name: 'journal12', page: 62, width: 1261, height: 1636 }),
        new AdventureImage({ name: 'journal13', page: 64, width: 1045, height: 945 }),
        new AdventureImage({ name: 'journal14', page: 66, width: 605, height: 605 }),
        new AdventureImage({ name: 'journal15', page: 68, width: 1261, height: 1636 }),
        new AdventureImage({ name: 'journal16', page: 70, width: 732, height: 1196 }),
        new AdventureImage({ name: 'journal17', page: 73, width: 865, height: 1011 }),
        new AdventureImage({ name: 'journal18', page: 74, width: 1261, height: 1636 }),
        new AdventureImage({ name: 'journal19', page: 76, width: 482, height: 379 }),
        new AdventureImage({ name: 'journal20', page: 77, width: 596, height: 596 }),
        new AdventureImage({ name: 'journal21', page: 78, width: 883, height: 1017 }),

        new CaptionImage({ name: 'npc1', page: 8, width: 605, height: 1246 }),
        new CaptionImage({ name: 'npc2', page: 10, width: 741, height: 1280 }),
        new CaptionImage({ name: 'npc3', page: 14, width: 816, height: 1163 }),
        new CaptionImage({ name: 'npc4', page: 19, width: 891, height: 1128 }),
        new CaptionImage({ name: 'npc5', page: 24, width: 635, height: 912 }),
        new CaptionImage({ name: 'npc6', page: 25, width: 610, height: 1164 }),
        new CaptionImage({ name: 'npc7', page: 28, width: 826, height: 725 }),
        new CaptionImage({ name: 'npc8', page: 30, width: 924, height: 1065 }),
        new CaptionImage({ name: 'npc9', page: 33, width: 765, height: 1124 }),
        new CaptionImage({ name: 'npc10', page: 39, width: 774, height: 1024 }),
        new CaptionImage({ name: 'npc11', page: 41, width: 974, height: 1216 }),
        new CaptionImage({ name: 'npc12', page: 43, width: 899, height: 1200 }),
        new CaptionImage({ name: 'npc13', page: 45, width: 675, height: 1153 }),
        new CaptionImage({ name: 'npc14', page: 49, width: 719, height: 1247 }),
        new CaptionImage({ name: 'npc15', page: 51, width: 753, height: 1094 }),
        new CaptionImage({ name: 'npc16', page: 53, width: 457, height: 1113 }),
        new CaptionImage({ name: 'npc17', page: 55, width: 666, height: 1078 }),
        new CaptionImage({ name: 'npc18', page: 56, width: 938, height: 1085 }),
        new CaptionImage({ name: 'npc20', page: 58, width: 911, height: 1093 }),
        new CaptionImage({ name: 'npc21', page: 60, width: 768, height: 1112 }),
        new CaptionImage({ name: 'npc22', page: 80, width: 477, height: 1050 }),
        new CaptionImage({ name: 'npc23', page: 81, width: 790, height: 1056 }),
        new CaptionImage({ name: 'npc24', page: 82, width: 811, height: 1168 }),
        new CaptionImage({ name: 'npc25', page: 83, width: 773, height: 1119 }),
        new CaptionImage({ name: 'npc26', page: 85, width: 815, height: 984 }),
        new CaptionImage({ name: 'npc27', page: 86, width: 817, height: 1050 }),
        new CaptionImage({ name: 'npc28', page: 87, width: 677, height: 1117 }),
        new CaptionImage({ name: 'npc29', page: 89, width: 872, height: 1360 }),
        new CaptionImage({ name: 'npc30', page: 91, width: 855, height: 1225 }),
        new CaptionImage({ name: 'npc31', page: 93, width: 807, height: 1259 }),
    ],
    finalize: (moduleData: ModuleData) => {
    }
};

export default adventureModule;